package nl.amis.android;

import java.util.ArrayList;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.drawable.Drawable;

import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.OverlayItem;

public class MarkerLayer extends ItemizedOverlay<OverlayItem> {
	
	private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();

	public MarkerLayer(Drawable defaultMarker) {
		// Define a binding point for where an overlay item is attached to the map
		super(boundCenterBottom(defaultMarker));
		// Prepare an OverlayItem element and draw it on the map
		populate();
	}
	
	public void addOverlayItem(OverlayItem overlay) {
		// Add an OverlayItem to the container mOverlays
		mOverlays.add(overlay);
		// Prepare an OverlayItem element and draw it on the map
		populate();
	}

	@Override
	protected OverlayItem createItem(int i) {
		return mOverlays.get(i);
	}

	@Override
	public int size() {
		return mOverlays.size();
	}
	
	@Override
	protected boolean onTap(int index) {
		// Provide a dialog box when an overlay item is clicked
		AlertDialog.Builder dialog = new AlertDialog.Builder(SpeedTraps.mContext);
		dialog.setTitle(mOverlays.get(index).getTitle());
		dialog.setMessage(mOverlays.get(index).getSnippet());
		dialog.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int whichButton) {
				dialog.cancel();
			}
		});		
		dialog.show();
		return super.onTap(index);
	}

}
